package daba;

import daba.db.Administrator;
import daba.db.Student;
import daba.db.Teacher;
import java.io.IOException;
import java.io.PrintWriter;
import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

@WebServlet(name = "InsertServlet", urlPatterns = {"/insertservlet"})
public class InsertServlet extends HttpServlet {

    @PersistenceContext
    private EntityManager entityManager;
    
    @Resource
    private UserTransaction userTra;
    
    private void printHeaderAndIntro(PrintWriter out)
    {
        out.println("<!DOCTYPE html>");
        out.println("<html>");
        out.println("<head>");
        out.println("<title>Inserting a new record</title>");            
        out.println("</head>");
        out.println("<body><a href=\"./\">go back</a>");            
    }
    
    private void printFooter(PrintWriter out)
    {
        out.println("</body>");
        out.println("</html>");        
    }
    
    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        
        try (PrintWriter out = response.getWriter()) {

            printHeaderAndIntro(out);
            
            Object objectToInsert = null;
            String submit = request.getParameter("submit");
            if (submit.equals("INSERT STUDENT"))
            {                
                objectToInsert = Student.newStudent(
                                    request.getParameter("firstname"),
                                    request.getParameter("lastname"),
                                    Long.parseLong(request.getParameter("yearstarted")),
                                    request.getParameter("direction"));
            }
            else if (submit.equals("INSERT TEACHER"))
            {
                objectToInsert = Teacher.newTeacher(
                                    request.getParameter("firstname"),
                                    request.getParameter("lastname"),
                                    Long.parseLong(request.getParameter("yearstarted")),
                                    request.getParameter("department"));
            }
            else if (submit.equals("INSERT ADMINISTRATOR"))
            {
                objectToInsert = Administrator.newAdministrator(
                                    request.getParameter("firstname"),
                                    request.getParameter("lastname"),
                                    Long.parseLong(request.getParameter("yearstarted")),
                                    request.getParameter("position"));
            }            
            
            try {
                    userTra.begin();
                    entityManager.persist(objectToInsert);
                    userTra.commit();
                    out.println("record inserted");
            } catch (Exception e)        
            {
                out.println("Exception!");
                e.printStackTrace(out);
            }
                      
            printFooter(out);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
