package daba.db;

import java.io.Serializable;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.MapsId;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table(name = "AISStudent")
public class Student implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    private Long ID;

    @OneToOne(cascade = CascadeType.ALL) @MapsId("ID")
    private Person person;
    
    private String DIRECTION;
       
    public Person getPerson()
    {
        return person;
    }
    
    public static Student newStudent(String firstname, 
                                     String lastname, 
                                     long yearStarted,
                                     String direction)
    {
        Student newst = new Student();        
        newst.person = Person.newPerson(firstname, lastname, yearStarted);
        newst.DIRECTION = direction;
        return newst;
    }
    
    public Long getId() {
        return ID;
    }

    public void setId(Long id) {
        this.ID = id;
    }

    public String getDirection() {
        return DIRECTION;
    }    
    
    public void setDirection(String direction)
    {
        this.DIRECTION = direction;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (ID != null ? ID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Student)) {
            return false;
        }
        Student other = (Student) object;
        if ((this.ID == null && other.ID != null) || (this.ID != null && !this.ID.equals(other.ID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "daba.Student[ id=" + ID + " ]";
    }
    
}
