package daba.db;

import java.io.Serializable;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.MapsId;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@Entity
@Table(name = "AISTeacher")
public class Teacher implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    private Long ID;
    
    @OneToOne(cascade = CascadeType.ALL) @MapsId("ID")
    private Person person;
    
    private String DEPARTMENT;
    
    public Person getPerson()
    {
        return person;
    }
    
    public static Teacher newTeacher(String firstname, 
                                     String lastname, 
                                     long yearStarted,
                                     String department)
    {
        Teacher newte = new Teacher();
        newte.person = Person.newPerson(firstname, lastname, yearStarted);
        newte.DEPARTMENT = department;
        return newte;
    }
    
    public Long getId() {
        return ID;
    }

    public void setId(Long id) {
        this.ID = id;
    }
    
    public String getDepartment()
    {
        return DEPARTMENT;
    }
    
    public void setDepartment(String department)
    {
        DEPARTMENT = department;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (ID != null ? ID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Teacher)) {
            return false;
        }
        Teacher other = (Teacher) object;
        if ((this.ID == null && other.ID != null) || (this.ID != null && !this.ID.equals(other.ID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "daba.Teacher[ id=" + ID + " ]";
    }
    
}
